#include <stdio.h>
#include <windows.h>

DWORD find_torrent_data(HANDLE hFile) 
{
	DWORD bytesread;
	IMAGE_DOS_HEADER dos_header;
	IMAGE_NT_HEADERS nt_header;
	IMAGE_SECTION_HEADER objtbl_entry;
	int i;
	DWORD retVal;

	ReadFile(hFile, &dos_header, sizeof(dos_header), &bytesread, NULL);
	if (bytesread != sizeof(dos_header) || dos_header.e_magic != IMAGE_DOS_SIGNATURE)
		return 0;

	SetFilePointer(hFile, dos_header.e_lfanew, NULL, FILE_BEGIN);
	ReadFile(hFile, &nt_header, sizeof(nt_header), &bytesread, NULL);
	if (bytesread != sizeof(nt_header) || nt_header.Signature != IMAGE_NT_SIGNATURE ||
		nt_header.FileHeader.SizeOfOptionalHeader == 0) 
		return 0;

	retVal = 0;
	for (i=0; i<nt_header.FileHeader.NumberOfSections; i++) {
		ReadFile(hFile, &objtbl_entry, sizeof(IMAGE_SECTION_HEADER), &bytesread, NULL);
		if (objtbl_entry.PointerToRawData >= retVal)
			retVal = objtbl_entry.PointerToRawData + objtbl_entry.SizeOfRawData;
	}  /* for i -> numsections */
	
	return retVal;
}

BOOL copy_file_part(HANDLE hFile, const char *fnameout, const DWORD start, DWORD len)
{
	char buff[4096];
	DWORD dwRead;
	HANDLE hFileOut;

	if ((hFileOut = CreateFile(fnameout, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, 0)) == INVALID_HANDLE_VALUE)
		return FALSE;

	SetFilePointer(hFile, start, 0, FILE_BEGIN);

	while (len)
	{
		dwRead = 0;
		if (len > sizeof(buff))
			ReadFile(hFile, buff, sizeof(buff), &dwRead, NULL);
		else
			ReadFile(hFile, buff, len, &dwRead, NULL);
		if (dwRead)
			WriteFile(hFileOut, buff, dwRead, &dwRead, NULL);
		else
			break;
		len -= dwRead;
	}

	CloseHandle(hFileOut);
	return TRUE;
}

int main(int argc, char argv[])
{
	WIN32_FIND_DATA wfd;
	HANDLE hFind;
	HANDLE hFile;
	DWORD start, len;
	FILETIME highestft;
	char fname[MAX_PATH], fnameout[MAX_PATH], *fnamedot;

	if ((hFind = FindFirstFile("WoW-*-downloader.exe", &wfd)) == INVALID_HANDLE_VALUE)
	{
		printf("Could not find any WoW-*-downloader.exe\n");
		return 1;
	}

	ZeroMemory(&highestft, sizeof(highestft));
	do {
		if (wfd.ftLastWriteTime.dwHighDateTime > highestft.dwHighDateTime || 
			(wfd.ftLastWriteTime.dwHighDateTime = highestft.dwHighDateTime && wfd.ftLastWriteTime.dwLowDateTime > highestft.dwLowDateTime)
			)
		{
			highestft = wfd.ftLastWriteTime;
			strcpy(fname, wfd.cFileName);
		}

		if (FindNextFile(hFind, &wfd) == 0) 
			break;
	} while (NULL != hFind && INVALID_HANDLE_VALUE != hFind);

	FindClose(hFind);

	printf("Extracting from %s...\n", fname);

	if ((hFile = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0)) == INVALID_HANDLE_VALUE)
		return 1;

	if (start = find_torrent_data(hFile))
	{
		len = SetFilePointer(hFile, 0, 0, FILE_END) - start;
		printf("Torrent should be at 0x%x len 0x%x\n", start, len);

		fnamedot = strrchr(fname, '.');
		if (fnamedot)
		{
			*fnamedot = 0;
			sprintf(fnameout, "%s.torrent", fname);
			printf("Saving torrent to %s...\n", fnameout);
			if (copy_file_part(hFile, fnameout, start, len))
				ShellExecute(0, NULL, fnameout, NULL, NULL, SW_NORMAL);
		}
	}  /* if found start */
	
	CloseHandle(hFile);

	return 0;
}